REM File: Bytefree v1.3a for Dndbbs v5.0a Release r1.0

REM Gets free disk drive space on default drive and
REM  prints the value to output file.

REM Uses a shell to Cmd.exe or path in Comspec.

REM Compile: BC Bytefree/ah/s/e/g3/o;
REM Link: LINK Bytefree/e;

REM Version v1.1a - add comspec.
REM Version v1.2a - add /d switch.
REM Version v1.3a - add /l switch.

ON ERROR GOTO Error.Routine1

V$=Command$
If Instr(V$,"/D") Then
   Debug=-1
Endif
V=Instr(V$,"/L:")
If V Then
   X$=Mid$(V$,V+3,1)
   If X$>="C" And X$<="Z" Then
      Drive$=X$+":\"
   Endif
Endif
If V$="/?" Then
   Color 15,0
   Print "Bytefree v1.3a"
   Color 14,0
   Print "Usage:"
   Color 15,0
   Print "  Bytefree [/D][/L:<c>]"
   Color 14,0
   Print "Where:"
   Color 15,0
   Print "  /D   -  debug mode."
   Print "  /L:<c>  -  check drive <c>"
   Color 7,0
   End
Endif
If debug Then
   Color 15,0
   Print "Bytefree v1.3a"
Endif
d$ = "cmd.exe"
GOSUB GetFreeSpace
IF x# THEN
   If Debug Then
      Color 15,0
      PRINT "Used Cmd.exe: Space:"; x#
   Endif
   CLOSE
   OPEN "freedisk.out" FOR OUTPUT AS #1
   PRINT #1, x#
   Color 7,0
   END 0
END IF

d$ = ENVIRON$("COMSPEC")
GOSUB GetFreeSpace
IF x# THEN
   If Debug Then
      Color 15,0
      PRINT "Used Comspec: Space:"; x#
   Endif
   CLOSE
   OPEN "freedisk.out" FOR OUTPUT AS #1
   PRINT #1, x#
   Color 7,0
   END 0
END IF
If debug Then
   Color 15,0
   Print "Drive "+Drive$+" not found."
Endif
Color 7,0
END 1

GetFreeSpace:
x# = 0#
CLOSE
IF DIR$("file.out") <> "" THEN
   KILL "file.out"
END IF
SHELL d$ + " /C dir "+Drive$+"*.* > file.out"
IF DIR$("file.out") = "" THEN
   RETURN
END IF
OPEN "file.out" FOR INPUT AS #1
x = 0
DO
   IF EOF(1) THEN
      EXIT DO
   END IF
   LINE INPUT #1, a$
   a$ = RTRIM$(a$)
   IF a$ <> "" THEN
      x$ = LCASE$(a$)
      x = INSTR(x$, "bytes free")
      IF x THEN
         EXIT DO
      END IF
   END IF
LOOP
IF x THEN
   V = INSTR(x$, "dir(s)")
   IF V THEN
      x$ = MID$(x$, V + 6)
      x = INSTR(x$, "bytes free")
   END IF
   x$ = LEFT$(x$, x - 1)
   x$ = RTRIM$(x$)

   ' remove commas
   DO
      l = INSTR(x$, ",")
      IF l THEN
         x$ = LEFT$(x$, l - 1) + MID$(x$, l + 1)
      ELSE
         EXIT DO
      END IF
   LOOP

   ' store value
   x# = INT(VAL(x$))
END IF

' delete temp file
CLOSE
IF DIR$("file.out") <> "" THEN
   KILL "file.out"
END IF
RETURN

' simple error routine
Error.Routine1:
If Debug Then
   PRINT "Critical error:"; ERR
Endif
END 1
